<?php

session_start();

include_once __DIR__ . '/vendor/autoload.php';
include_once __DIR__ . '/classes/CareCloudAPIAsync.php';

// Check if session variables are set
if (
  empty($_SESSION[CareCloudAPIAsync::APIURLKEY]) ||
  empty($_SESSION[CareCloudAPIAsync::EXTERNALAPPIDKEY]) ||
  empty($_SESSION[CareCloudAPIAsync::LANGUAGEKEY]) ||
  empty($_SESSION[CareCloudAPIAsync::APIURLKEY] ||
  empty($_SESSION[CareCloudAPIAsync::APITOKENKEY]))
) {
  echo json_encode(array(
    'error' => 'Something went wrong.'
  ));
  exit;
}

$ApiAsync = new CareCloudAPIAsync(
  $_SESSION[CareCloudAPIAsync::APIURLKEY],
  $_SESSION[CareCloudAPIAsync::EXTERNALAPPIDKEY],
  $_SESSION[CareCloudAPIAsync::APITOKENKEY],
  $_SESSION[CareCloudAPIAsync::LANGUAGEKEY],
  $_SESSION[CareCloudAPIAsync::CUSTOMERIDKEY]
);


$input_data = json_decode(file_get_contents('php://input'), true) ?: $_POST;
$data = (isset($input_data) && isset($input_data['data'])) ? $input_data['data'] : array();

$route = (isset($input_data['route'])) ? $input_data['route'] : null;
$method = $input_data['method'] ?? "GET";
//$data = isset($input_data['data']) ? $input_data['data'] : array();


try {
  if (isset($input_data['action']) && $input_data['action'] === 'carecloud_user_api')
    $res = $ApiAsync->customerAPIUserCall($route, $method, $data);
  elseif($input_data['action'] === 'carecloud_api')
  {
    $res = $ApiAsync->customerAPICall($route, $method, $data);
  }
  elseif($input_data['action'] === 'integration_layer')
  {
    $res = $ApiAsync->integrationSericeAPICall($route, $method, $data);
  } else
    throw new Exception("Unknown action.");

} catch (\GuzzleHttp\Exception\BadResponseException $e) {
  $res = json_decode($e->getResponse()->getBody()->getContents());
} catch (\Exception $e) {
  $res = array('error' => 'An error has occurred.');
}

echo json_encode($res);
exit;